c______________________________________________________________________
c
      subroutine wait_press (keyname_in)
c
c  DUMMY DUMMY - UNIX
c
c   waiting for pressing key 'keyname'
c   accept low and/or upper letters
c______________________________________________________________________
c
      character   keyname*8,keyname_in*(*),nam_list(5)*8
      integer*2   key,key_tst,cod_list(5)
cc    logical     key_waiting@
      data        list_mx /5/
      data cod_list
cc     +   / Z'1B',Z'0D',Z'20'  ,Z'03',  Z'26'   /
     +     /   27 ,  13 ,  32   ,   3 ,    38    /
      data nam_list
     +   / 'ESC','RET','SPACE','CTRLC','CTRLZ' /
c
      read (*,'(a8)') keyname
c
      return
      end
c______________________________________________________________________
c
      subroutine wait_press_prompt (keyname_in)
c
c
c  DUMMY DUMMY - UNIX
c
c   waiting for pressing key 'keyname'
c   with corresponding prompt
c______________________________________________________________________
c
      character   keyname_in*(*),keyname*8,keyprompt*10,keyblank*10
      integer*2   icurv,icurh,icur_typ,iattribute
c
      INTEGER*2 BLACK,BLUE,INVERSE_BLUE,GREEN,INVERSE_GREEN,
     +CYAN,INVERSE_CYAN,RED,INVERSE_RED,MAGENTA,INVERSE_MAGENTA,
     +BROWN,INVERSE_BROWN,YELLOW,INVERSE_YELLOW,WHITE,INVERSE_WHITE,
     +INTENSE,BLINKING
      PARAMETER(BLACK=0)
      PARAMETER(BLUE=1,INVERSE_BLUE=16)
      PARAMETER(GREEN=2,INVERSE_GREEN=32)
      PARAMETER(CYAN=3,INVERSE_CYAN=48)
      PARAMETER(RED=4,INVERSE_RED=64)
      PARAMETER(MAGENTA=5,INVERSE_MAGENTA=80)
      PARAMETER(BROWN=6,INVERSE_BROWN=96)
      PARAMETER(YELLOW=14,INVERSE_YELLOW=8+96)
      PARAMETER(WHITE=7,INVERSE_WHITE=7*16)
      PARAMETER(INTENSE=8)
      PARAMETER(BLINKING=128)
c
      data        keyblank /'          '/
c
      write (*,'(''........ please, press any key .........'')')
      read (*,'(a8)') keyname
      return
      end
c______________________________________________________________________
c
      subroutine wait_press_cursor (keyname_in)
c
c
c  DUMMY DUMMY - UNIX
c
c   waiting for pressing key 'keyname'
c   accept low and/or upper letters
c______________________________________________________________________
c
      character   keyname*8,keyname_in*(*),nam_list(5)*8
      integer*2   key,key_tst,cod_list(5),icur_typ
      integer*2   icurh,icurv,icurh_old,icurv_old
cc    logical     key_waiting@
      data        list_mx /5/
      data cod_list
cc     +   / Z'1B',Z'0D',Z'20'  ,Z'03',  Z'26'   /
     +     /   27 ,  13 ,  32   ,   3 ,    38    /
      data nam_list
     +   / 'ESC','RET','SPACE','CTRLC','CTRLZ' /
c
      write (*,'(''........ please, press any key .........'')')
      read (*,'(a8)') keyname
      return
      end
c______________________________________________________________________
c
      logical function ask_press (keyname_in)
c
c
c  DUMMY DUMMY - UNIX
c
c  asking if key 'keyname' is highest in keyboard stack,
c  accept low and/or upper letters
c______________________________________________________________________
c
      character   keyname*8,keyname_in*(*),nam_list(5)*8
      integer*2   key,key_tst,cod_list(5)
cc    logical     key_waiting@
      data        list_mx /5/
      data cod_list
cc     +   / Z'1B',Z'0D',Z'20'  ,Z'03',  Z'26'   /
     +     /   27 ,  13 ,  32   ,   3 ,    38    /
      data nam_list
     +   / 'ESC','RET','SPACE','CTRLC','CTRLZ' /
c
      ask_press = .false.
      return
      end
c______________________________________________________________________
c
      subroutine sfd (str80,ipos)
c
c  search for first $
c______________________________________________________________________
c
      character*(*) str80
      data icmx / 80 /
      ipos = 1
   10 continue
      if (str80 (ipos:ipos).eq.'$') go to 900
        ipos = ipos + 1
      if (ipos.lt.icmx) then
        go to   10
      else
        ipos = icmx
      endif
900   ipos = ipos - 1
      return
      end
c______________________________________________________________________
c
      subroutine getint (strng,int)
c
c  get an integer in dialog from terminal (string terminated by $)
c______________________________________________________________________
c
      character*(*) strng
      call sfd (strng,ip)
   10 write (*,'(80A1)') (strng(i:i), i=1,ip)
      read  (*,'(I10)',err=10) int
cc    write (*,'(I10)') int
      end
c______________________________________________________________________
c
      subroutine getrea (strng,rea)
c
c  get an real in dialog from terminal (string terminated by $)
c______________________________________________________________________
c
      character*(*) strng
      call sfd (strng,ip)
   10 write (*,'(80A1)') (strng(i:i), i=1,ip)
      read  (*,*,err=10) rea
cc    write (*,*) rea
      end
c______________________________________________________________________
c
      subroutine getcha (strng,cha)
c
c  get an character in dialog from terminal (string terminated by $)
c______________________________________________________________________
c
      character*(*) strng
      character*96 cha
      call sfd (strng,ip)
   10 write (*,'(80A1)') (strng(i:i), i=1,ip)
      read  (*,'(A96)',err=10) cha
cc    write (*,'(A96)') cha
      end
c______________________________________________________________________
c
      subroutine mygetlog (strng,nyes)
c
c  get an logical in "No/Yes"-dialog from terminal
c  print strng up to first $ (max. 80 char)
c______________________________________________________________________
c
      character*(*) strng
      character*1 c
      logical nyes
c
      call sfd (strng,ip)
    1 write (*,'(80A1)') (strng(i:i),i=1,ip)
      read  (*,'(A1)') c
      if (c.eq.'y'.or.c.eq.'Y')   then
          nyes = .true.
      elseif (c.eq.'n'.or.c.eq.'N')   then
          nyes = .false.
      else
          go to 1
      endif
cc    write (*,'(A1)') c
      return
      end
c______________________________________________________________________
c
      subroutine delay_seconds (iseconds)
c
c
c  DUMMY DUMMY - UNIX
c
c  ... delay iseconds seconds,
c      self adjusting at start (ftn77-switches dependent)
c______________________________________________________________________
c
      save     init, irunsec
      real*8   timstart,timstop,timsec
      data     init /0/, iruntest /3 500 000/
c
      return
      end
c______________________________________________________________________
c
      subroutine upper_case (string)
c
c  ... transform to upper case ...
c______________________________________________________________________
c
      character  string*(*),lett*1,letter_lo(26)*1,letter_up(26)*1
c
      data nletter /  26  /
      data letter_lo
     +   /'a','b','c','d','e','f','g','h','i','j',
     +    'k','l','m','n','o','p','q','r','s','t',
     +    'u','v','w','x','y','z'  /
      data letter_up
     +   /'A','B','C','D','E','F','G','H','I','J',
     +    'K','L','M','N','O','P','Q','R','S','T',
     +    'U','V','W','X','Y','Z'  /
c
      il = len (string)
      do  i = 1, il
        lett = string(i:i)
        do  j = 1, nletter
          if (lett.eq.letter_lo(j))    lett = letter_up(j)
        enddo
        string(i:i) = lett
      enddo
      end
